//////////////////////////////////////////////////////////////////////////////
//
// $Id: example.C,v 1.2 2001/06/24 13:43:30 assman Exp $
//
// $Log: example.C,v $
// Revision 1.2  2001/06/24 13:43:30  assman
// added full cvs tags
//
//
//////////////////////////////////////////////////////////////////////////////

#include <threadedserver>
#include <lock>

class DummyServer: public GenericThreadServer {
public:
  DummyServer(int maxth, int block=0):
    GenericThreadServer(maxth,block) { }
  
  virtual ~DummyServer() { }
  

  void *_dispatchthread(void) {
    int n;
    while (1) {
	cout << "getting lock" << endl;
      _pth_lock.wait();       
   
      cout << "-----------" << endl;
      for (n=0; n<10; n++) {
	  cout << "Thread " << pthread_self() << ": " << n << endl;
      }
    }
  }

  void _workerdispatchthread(void) {
      int n,k;
      k=0;
      for (k=0; k<10; k++) {
	  for (n=0; n<_pth_max_num; n++) {
	      _pth_lock.signal();
	  }
	  sleep(1);
      }
  }

protected:

	LockCond _pth_lock;
}; 

//////////////////////////////////////////////////////////////////////////////
// 
// Implementation
//
//////////////////////////////////////////////////////////////////////////////

/*
void GenericServer::_workerdispatchthread(void) {
ConnData *conn=NULL;
 
  while (1) {

   conn = _conn->accept();
   if (conn==NULL) continue;

    //
    // test if create a new thread
    //

   if (_stack.full()) {

      //
      // max number of threads get. Send the
      // sorry message and close the conection
      //
     
     maxthreadmsg(conn,_pth_num);
     
      conn->close();
      delete conn;

    }
    else {
      //
      // wake up a thread and do the work
      //

      _stack.push(conn);
      _pth_lock.signal();

    }
  }

  return;
}
*/

//////////////////////////////////////////////////////////////////////////////
//
// main
//
//////////////////////////////////////////////////////////////////////////////

 int main(int argc, char *argv[]) {
   
   DummyServer d(10,1);

   d.createthreads();
   d.dispatch();
 }


